# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend

    The version of the OpenAPI document: api/v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictStr

from typing import Any, Dict, Optional

from scicat_sdk_pydantic.models.user_identity import UserIdentity

from scicat_sdk_pydantic.api_client import ApiClient
from scicat_sdk_pydantic.api_response import ApiResponse
from scicat_sdk_pydantic.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class UserIdentitiesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def user_identities_controller_find_one(self, filter : Annotated[Optional[StrictStr], Field(description="Full database filters to apply when checking for the email. The filter can be just the where clause or the full filter syntax <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>")] = None, **kwargs) -> UserIdentity:  # noqa: E501
        """user_identities_controller_find_one  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.user_identities_controller_find_one(filter, async_req=True)
        >>> result = thread.get()

        :param filter: Full database filters to apply when checking for the email. The filter can be just the where clause or the full filter syntax <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>
        :type filter: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: UserIdentity
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the user_identities_controller_find_one_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.user_identities_controller_find_one_with_http_info(filter, **kwargs)  # noqa: E501

    @validate_arguments
    def user_identities_controller_find_one_with_http_info(self, filter : Annotated[Optional[StrictStr], Field(description="Full database filters to apply when checking for the email. The filter can be just the where clause or the full filter syntax <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """user_identities_controller_find_one  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.user_identities_controller_find_one_with_http_info(filter, async_req=True)
        >>> result = thread.get()

        :param filter: Full database filters to apply when checking for the email. The filter can be just the where clause or the full filter syntax <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>
        :type filter: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(UserIdentity, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'filter'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method user_identities_controller_find_one" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('filter') is not None:  # noqa: E501
            _query_params.append(('filter', _params['filter']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "UserIdentity",
        }

        return self.api_client.call_api(
            '/api/v3/useridentities/findOne', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def user_identities_controller_is_valid_email(self, filter : Annotated[Optional[StrictStr], Field(description="Email to be checked or full filter format query to apply when checking for the email <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>")] = None, **kwargs) -> object:  # noqa: E501
        """It returns true if the emailed passed in is linked to any registered users  # noqa: E501

        This endpoint check if the email passed in as parameter is a valid email connected to a known user that has a record in this instance of SciCat  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.user_identities_controller_is_valid_email(filter, async_req=True)
        >>> result = thread.get()

        :param filter: Email to be checked or full filter format query to apply when checking for the email <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>
        :type filter: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the user_identities_controller_is_valid_email_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.user_identities_controller_is_valid_email_with_http_info(filter, **kwargs)  # noqa: E501

    @validate_arguments
    def user_identities_controller_is_valid_email_with_http_info(self, filter : Annotated[Optional[StrictStr], Field(description="Email to be checked or full filter format query to apply when checking for the email <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """It returns true if the emailed passed in is linked to any registered users  # noqa: E501

        This endpoint check if the email passed in as parameter is a valid email connected to a known user that has a record in this instance of SciCat  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.user_identities_controller_is_valid_email_with_http_info(filter, async_req=True)
        >>> result = thread.get()

        :param filter: Email to be checked or full filter format query to apply when checking for the email <pre>    this_email@some.site  or     {      \"email\": \"this_email@some.site\"    }  or     {      \"profile.email\": \"this_email@some.site\"    }  or     {      \"where?\": {        \"profile.email\": \"this_email@some.site\"      }    }  This last version is deprecated and will be discontinued as soon as the FE is updated.  It has been maintanined for backward compatibility.  </pre>
        :type filter: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'filter'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method user_identities_controller_is_valid_email" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('filter') is not None:  # noqa: E501
            _query_params.append(('filter', _params['filter']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "object",
            '201': "object",
        }

        return self.api_client.call_api(
            '/api/v3/useridentities/isValidEmail', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
