# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend

    The version of the OpenAPI document: api/v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List
from pydantic import BaseModel, Field, StrictStr, conlist

class Logbook(BaseModel):
    """
    Logbook
    """
    name: StrictStr = Field(...)
    room_id: StrictStr = Field(default=..., alias="roomId")
    messages: conlist(Dict[str, Any]) = Field(...)
    __properties = ["name", "roomId", "messages"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Logbook:
        """Create an instance of Logbook from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Logbook:
        """Create an instance of Logbook from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Logbook.parse_obj(obj)

        _obj = Logbook.parse_obj({
            "name": obj.get("name"),
            "room_id": obj.get("roomId"),
            "messages": obj.get("messages")
        })
        return _obj


